from random import randint, seed, shuffle
from string import ascii_lowercase as abc
seed(47)

PLATIDLA = [1, 2, 5, 10, 20, 50, 100, 200, 500, 1000, 2000, 5000, 10000, 20000, 50000]

def save(fname, X, T):
    f = open( fname, 'w' )
    print( X, file=f )
    print( len(T), file=f )
    print( *T, file=f )
    f.close()

save('0.sample.in', 4700, [53, 9400, 9401, 30000] )

for tc, X in zip( 'abcde', [3, 4, 7, 12, 18] ):
    T = list(range(1,21))
    shuffle(T)
    save('1.'+tc+'.in', X, T)

save('2.a.in', 100000, [ randint(1,100000) for _ in range(50) ] )

for tc in range(13):
    while True:
        X = randint( 2**(tc+4), min(10**5,2**(tc+5)-1) )
        if X not in PLATIDLA: break
    T = [ randint(1,10**5) for _ in range(50) ]
    save('3.'+abc[tc]+'.in', X, T)

for tc in range(19):
    while True:
        X = randint( 2**(tc+4), min(10**7,2**(tc+5)-1) )
        if X not in PLATIDLA: break
    T = [ randint(1,10**7) for _ in range(50) ]
    save('4.'+abc[tc]+'.in', X, T)

for tc in range(26):
    while True:
        X = randint( 2**(tc+5), min(2000000000,2**(tc+6)-1) )
        if X not in PLATIDLA: break
    T = [ randint(1,2000000000) for _ in range(50) ]
    save('5.'+abc[tc]+'.in', X, T)

