#include <bits/stdc++.h>
using namespace std;

const vector<int> POVODNE_PLATIDLA = {50000,20000,10000,5000,2000,1000,500,200,100,50,20,10,5,2,1};

int pazravo(int t) {
    int odpoved = 0;
    for (int p : POVODNE_PLATIDLA) {
        odpoved += t/p;
        t %= p;
    }
    return odpoved;
}

int main() {
    int X, Q;
    cin >> X >> Q;
    while (Q--) {
        int T;
        cin >> T;
        int najlepsie = pazravo(T);
        for (int px=1; px<najlepsie && 1LL*px*X <= T; ++px) najlepsie = min( najlepsie, px + pazravo(T-px*X) );
        cout << najlepsie << endl;
    }
}
